"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.guard = void 0;
const symbols_1 = require("./symbols");
const utils_1 = require("./utils");
function guard(...[name, guardFn, handleOptions, defaultOptions]) {
    return (0, utils_1.makeValit)(name, (fn) => {
        const validateFn = ((value, options, path, parent) => {
            const res = fn(value, options, path, parent);
            if ((0, utils_1.isValid)(res))
                return {
                    valid: true,
                    data: res,
                    errors: [],
                };
            return {
                valid: false,
                data: undefined,
                errors: [
                    {
                        message: `vality.${name}.base`,
                        path,
                        options,
                        value,
                    },
                ],
            };
        });
        validateFn[symbols_1._type] = fn[symbols_1._type];
        return validateFn;
    }, handleOptions, defaultOptions)(guardFn);
}
exports.guard = guard;
