import { Guard } from "./guard";
import { RelationType } from "./parse";
import { Primitive, RSE } from "./utils";
import { Valit } from "./valit";
declare global {
    namespace vality {
        interface guards {
            string: Guard<"string", string, {
                minLength: number;
                maxLength: number;
                match: RegExp;
            }>;
            number: Guard<"number", number, {
                min: number;
                max: number;
                integer: boolean;
                unsafe: boolean;
            }>;
            boolean: Guard<"boolean", boolean>;
            date: Guard<"date", Date, {
                min: Date;
                max: Date;
                past: boolean;
                future: boolean;
            }>;
            literal<P extends Primitive>(lit: P): Guard<"literal", P, {
                default: boolean;
            }>;
            relation<S extends () => RSE>(model: S): Valit<"relation", S, {
                transform: (v: RelationType) => RelationType;
            }>;
            any: Guard<"any", unknown>;
        }
    }
}
