import { Parse } from "./parse";
import { Face, Path, Validate, ValidateFn } from "./validate";
import { ValitFn } from "./valit";
export declare type RSA = Record<string, any>;
export declare type RSN = Record<string, never>;
export declare type RSE = {
    [K: string]: Eny;
};
export declare type MaybeArray<T> = T | T[];
export declare type Primitive = string | number | boolean | null;
export declare type _Eny = Primitive | Face<any, Primitive, any> | (() => Eny) | RSE;
export declare type Eny = MaybeArray<_Eny> | Readonly<MaybeArray<_Eny>>;
export declare type MakeRequired<T extends RSA, K extends keyof T> = {
    [key in K]-?: T[key];
} & {
    [key in Exclude<keyof T, K>]: T[key];
};
export declare function assert<T>(val: any, condition?: boolean): asserts val is T;
export declare function isValid<Type>(data: Type | undefined): data is Type;
export declare type EnyToFace<T> = T extends [infer U] ? Face<"array", U[], true> : T extends [...infer U] ? Face<"enum", U, true> : T extends Primitive ? Face<"literal", T, false> : T extends Face<any, any, any> ? T : T extends () => infer U ? Face<"relation", U, true> : Face<"object", T, true>;
export declare function enyToGuard<E extends Eny>(eny: E): EnyToFace<E>;
export declare function enyToGuardFn<E extends Eny>(e: E): ValidateFn<any>;
export declare function flat<T>(arr: T[][]): T[];
export declare type IdentityFn<T> = (x: T) => T;
export declare function identity<T>(x: T): T;
export declare function trueFn(..._args: any[]): true;
export declare function falseFn(..._args: any[]): false;
declare type Intersect<T> = (T extends any ? (x: T) => 0 : never) extends (x: infer R) => 0 ? R : never;
declare type TupleKeys<T extends any[]> = Exclude<keyof T, keyof []>;
declare type Foo<T extends any[]> = {
    [K in TupleKeys<T>]: {
        foo: T[K];
    };
};
declare type Values<T> = T[keyof T];
declare type Unfoo<T> = T extends {
    foo: any;
} ? T["foo"] : never;
export declare type IntersectItems<T extends any[]> = Unfoo<Intersect<Parse<Values<Foo<T>>>>>;
export declare type TOrFace<T> = T | Face<string, T, false> | Face<string, T | Face<string, T, true> | Face<string, T, false>, true>;
export declare type OneOrEnumOfTOrFace<T> = OneOrEnumOf<TOrFace<T>>;
export declare type OneOrEnumOf<T> = T | readonly [T, T, ...T[]];
export declare type SharedParameters<Name, Type, Options extends RSA, Fn> = [
    name: Name,
    fn: Fn,
    handleOptions?: {
        [K in Exclude<keyof Options, keyof ExtraOptions<Type, Options>>]?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K> & Partial<ExtraOptions<Type, Options>>) => boolean;
    },
    defaultOptions?: Partial<Options>
];
export declare type ExtraOptions<T, O> = {
    transform: IdentityFn<T>;
    preprocess: (val: unknown, options: Partial<CallOptions<T, O>>, path: Path, parent?: any) => unknown;
    default: T;
    validate: (val: T, options: Partial<CallOptions<T, O>>) => boolean;
};
export declare type CallOptions<Type, Options> = Options extends RSN ? ExtraOptions<Type, Options> : Options & Omit<ExtraOptions<Type, Options>, keyof Options>;
export declare function makeValit<Name extends keyof (vality.valits & vality.guards), Arg extends any[], Type, Options extends RSA, V extends boolean>(...[name, fn, handleOptions, defaultOptions]: SharedParameters<Name, Type, Options, (...args: Arg) => ValitFn<Type, Options>>): (...args: Arg) => Validate<Name, Type, Options, V>;
export {};
