"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeValit = exports.falseFn = exports.trueFn = exports.identity = exports.flat = exports.enyToGuardFn = exports.enyToGuard = exports.isValid = exports.assert = void 0;
const symbols_1 = require("./symbols");
const vality_1 = require("./vality");
function assert(val, condition) {
    if (condition === false) {
        throw new Error("Assertion failed");
    }
}
exports.assert = assert;
function isValid(data) {
    return data !== undefined;
}
exports.isValid = isValid;
function enyToGuard(eny) {
    if (Array.isArray(eny)) {
        if (eny.length === 0)
            throw new Error("Empty array short");
        if (eny.length === 1)
            return vality_1.vality.array(enyToGuard(eny[0]));
        return vality_1.vality.enum(...eny.map(enyToGuard));
    }
    if (typeof eny === "string" ||
        typeof eny === "number" ||
        typeof eny === "boolean" ||
        eny === null) {
        return vality_1.vality.literal(eny);
    }
    if (symbols_1._validate in eny)
        return eny;
    if (typeof eny === "function")
        return vality_1.vality.relation(eny);
    return vality_1.vality.object(eny);
}
exports.enyToGuard = enyToGuard;
function enyToGuardFn(e) {
    return enyToGuard(e)[symbols_1._validate];
}
exports.enyToGuardFn = enyToGuardFn;
function flat(arr) {
    return [].concat(...arr);
}
exports.flat = flat;
function identity(x) {
    return x;
}
exports.identity = identity;
function trueFn(..._args) {
    return true;
}
exports.trueFn = trueFn;
function falseFn(..._args) {
    return false;
}
exports.falseFn = falseFn;
function makeValit(...[name, fn, handleOptions, defaultOptions]) {
    return (...args) => {
        const getValidateFnFromOptions = (options) => (value, path, parent) => {
            const _a = Object.assign({}, options), { transform = undefined, preprocess = undefined, default: defaultValue = undefined, validate = undefined } = _a, optionsWithoutExtras = __rest(_a, ["transform", "preprocess", "default", "validate"]);
            const optionsWithDefault = Object.assign(Object.assign({}, defaultOptions), optionsWithoutExtras);
            if (preprocess) {
                value = preprocess(value, options, path, parent);
            }
            const data = fn(...args)(value, options, path, parent);
            if (!data.valid) {
                if (value === undefined && defaultValue !== undefined) {
                    return { valid: true, data: defaultValue, errors: [] };
                }
                return data;
            }
            if ((validate === null || validate === void 0 ? void 0 : validate(data.data, options)) === false) {
                return {
                    valid: false,
                    data: undefined,
                    errors: [
                        {
                            message: `vality.${name}.custom`,
                            path,
                            options,
                            value,
                        },
                    ],
                };
            }
            const origData = data.data;
            if (transform) {
                data.data = transform(data.data);
            }
            if (handleOptions === undefined)
                return data;
            const keysWithError = Object.keys(optionsWithDefault).filter((k) => {
                var _a;
                return ((_a = handleOptions[k]) === null || _a === void 0 ? void 0 : _a.call(handleOptions, origData, optionsWithDefault[k], options)) === false;
            });
            if (keysWithError.length === 0)
                return data;
            return {
                valid: false,
                data: undefined,
                errors: keysWithError.map((k) => ({
                    message: k in options
                        ? `vality.${name}.options.${k}`
                        : `vality.${name}.base`,
                    options,
                    path,
                    value,
                })),
            };
        };
        function applyFnType(f) {
            f[symbols_1._type] = args;
            return f;
        }
        const validate = ((options) => ({
            [symbols_1._validate]: applyFnType((val, path, parent) => {
                if (typeof options === "function")
                    options = options(parent);
                return getValidateFnFromOptions(options)(val, path, parent);
            }),
            [symbols_1._name]: name,
        }));
        validate[symbols_1._validate] = applyFnType(getValidateFnFromOptions({}));
        validate[symbols_1._name] = name;
        return validate;
    };
}
exports.makeValit = makeValit;
