import { ParseIn } from "./parse";
import { _name, _type, _validate } from "./symbols";
import { CallOptions, Eny } from "./utils";
export interface Error {
    message: string;
    path: Path;
    options: unknown;
    value: unknown;
}
export declare type Validate<Name extends string, Type, O, IsValit> = Face<Name, Type, IsValit> & ((options: Partial<CallOptions<Type, O>> | ((parent: any) => Partial<CallOptions<Type, O>>)) => Face<Name, Type, IsValit>);
export declare type Face<Name, Type, IsValit> = {
    [_name]: Name;
    [_validate]: ValidateFn<Type>;
    [_type]: Type;
    isValit?: IsValit;
};
export declare type ValidateFn<T> = (val: unknown, path: Path, parent: any) => ValidationResult<T>;
export declare type ValidationResult<T> = {
    valid: true;
    data: T;
    errors: never[];
} | {
    valid: false;
    data: undefined;
    errors: Error[];
};
export declare type Path = (string | number)[];
export declare function validate<E extends Eny>(schema: E, val: unknown, bail?: boolean): ValidationResult<ParseIn<E>>;
