import { Eny, OneOrEnumOfTOrFace, RSE } from "./utils";
import { Valit } from "./valit";
declare global {
    namespace vality {
        interface valits {
            array: <E extends Eny>(e: E) => Valit<"array", E[], {
                minLength: number;
                maxLength: number;
                bail: boolean;
            }>;
            tuple: <E extends Eny[]>(...es: E) => Valit<"tuple", E, {
                bail: boolean;
            }>;
            optional: <E extends Eny>(e: E) => Valit<"optional", undefined | E>;
            enum: <E extends Eny[]>(...es: E) => Valit<"enum", E[number]>;
            object: <E extends RSE>(v: E) => Valit<"object", E, {
                bail: boolean;
            }>;
            readonly: <E extends Eny>(e: E) => Valit<"readonly", E>;
            and: <E extends OneOrEnumOfTOrFace<RSE | Valit<"and", RSE[], any>>[]>(...es: E) => Valit<"and", E, {
                bail: boolean;
            }>;
            dict: <K extends OneOrEnumOfTOrFace<string | number>, V extends Eny>(k: K, v: V) => Valit<"dict", [
                K,
                V
            ], {
                bail: boolean;
            }>;
        }
    }
}
